/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.bpmn.views.utils {
  import flash.geom.Point;

  import mx.core.UIComponent;

  public class Arrow extends UIComponent {

    private var _sourcePoint:Point;

    private var _targetPoint:Point;

    private var style:ArrowStyle;

    public function Arrow(sourcePoint:Point, targetPoint:Point) {
      _sourcePoint = sourcePoint;
      _targetPoint = targetPoint;


      //Set the arrow style
      style = new ArrowStyle();
      style.headWidth = 11;
      style.headLength = 17;
      style.color = 0x000000;
      style.headFill = true;
      style.thickness = 0;

      //Draw an arrow from 30,30 to 100,100
      redrawGraphics();

    }

    public function get sourcePoint():Point {
      return _sourcePoint;
    }

    public function set sourcePoint(point:Point):void {
      _sourcePoint = point;
      redrawGraphics();


    }

    public function get targetPoint():Point {
      return _targetPoint;
    }

    public function set targetPoint(point:Point):void {
      _targetPoint = point;
      redrawGraphics();

    }

    public function setSourceAndTarget(sourcePoint:Point, targetPoint:Point):void {
      _sourcePoint = sourcePoint;
      _targetPoint = targetPoint;
      redrawGraphics();
    }


    private function redrawGraphics():void {
      ArrowUtil.drawArrow(this.graphics,
              _sourcePoint,
              _targetPoint,
              style);
    }
  }
}
